"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PatchObject = void 0;
const types_1 = require("../types");
class PatchObject {
    diffs = [];
    start1 = 0;
    start2 = 0;
    length1 = 0;
    length2 = 0;
    toString() {
        let coords1;
        let coords2;
        if (this.length1 === 0) {
            coords1 = this.start1 + ",0";
        }
        else if (this.length1 === 1) {
            coords1 = this.start1 + 1;
        }
        else {
            coords1 = (this.start1 + 1) + "," + this.length1;
        }
        if (this.length2 === 0) {
            coords2 = this.start2 + ",0";
        }
        else if (this.length2 === 1) {
            coords2 = this.start2 + 1;
        }
        else {
            coords2 = (this.start2 + 1) + "," + this.length2;
        }
        const text = ["@@ -" + coords1 + " +" + coords2 + " @@\n"];
        let op;
        for (let x = 0; x < this.diffs.length; x++) {
            switch (this.diffs[x][0]) {
                case types_1.DiffOperation.DIFF_INSERT:
                    op = "+";
                    break;
                case types_1.DiffOperation.DIFF_DELETE:
                    op = "-";
                    break;
                case types_1.DiffOperation.DIFF_EQUAL:
                    op = " ";
                    break;
            }
            text[x + 1] = op + encodeURI(this.diffs[x][1]) + "\n";
        }
        return text.join("").replace(/%20/g, " ");
    }
}
exports.PatchObject = PatchObject;
