import type { Diff } from "../types";
/**
 * Class representing one patch operation.
 *
 * Ported by [xiaochao.k@gmail.com](https://github.com/nonoroazoro)
 */
export declare class PatchObject {
    diffs: Diff[];
    start1: number;
    start2: number;
    length1: number;
    length2: number;
    /**
     * Emulate GNU diff format.
     * Header: @@ -382,8 +481,9 @@
     * Indices are printed as 1-based, not 0-based.
     *
     * @returns {string} The GNU diff string.
     */
    toString(): string;
}
